//*****************************************************************************
//* Copyright (c) 2001-2005 Miday Workshop All rights reserved.
//*
//* File: DateSpot.c
//*****************************************************************************
#include <PalmOS.h>
#include "DateSpot.h"

short Md_max_color;
DmOpenRef Md_dbP;
short Md_version;
unsigned long Md_holidayc;//t
unsigned long Md_holidayb[31] = {
 0x00000001, 0x00000002, 0x00000004, 0x00000008, 0x00000010, 0x00000020, 0x00000040, 0x00000080,
 0x00000100, 0x00000200, 0x00000400, 0x00000800, 0x00001000, 0x00002000, 0x00004000, 0x00008000,
 0x00010000, 0x00020000, 0x00040000, 0x00080000, 0x00100000, 0x00200000, 0x00400000, 0x00800000,
 0x01000000, 0x02000000, 0x04000000, 0x08000000, 0x10000000, 0x20000000, 0x40000000 };
Md_HOL_COLOR Md_hol_color[Md_Max_Color_no];

short Md_OS_Color_Support; //add 2005/12/24

//J[ǂ`FbN
void Md_ColorSupportCheck() {
	Err error;
	unsigned long romVersion;
	UInt32 depth;

	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < sysMakeROMVersion(3,5,0,sysROMStageRelease,0)) {
		Md_OS_Color_Support = 0;//mN
	} else {
		error = WinScreenMode(winScreenModeGet, NULL, NULL, &depth, NULL);
		if ( depth > 4 ) {
			Md_OS_Color_Support = 1;//J[
		} else {
			Md_OS_Color_Support = 0;//mN
		}
	}
}

//Ff[^ݒiFf[^̎w肪Ȃꍇo[WQȉj
static void Md_InitRedDate(){
	Md_hol_color[0].hol_flag = 1;
	Md_hol_color[1].hol_flag = 1;

	Md_hol_color[0].color1_b = 125;
	Md_hol_color[1].color1_b = 207;
	Md_hol_color[0].color2_b = 3;
	Md_hol_color[1].color2_b = 174;

	Md_hol_color[0].color1_t = 0;
	Md_hol_color[1].color1_t = 0;
	Md_hol_color[0].color2_t = 0;
	Md_hol_color[1].color2_t = 0;

	Md_max_color = 2;
}

//Ff[^荞
void Md_GetColorDate(){
	Int16 offset;
	UInt16 CurrentCategory;
	MemHandle recHdl;
	UInt16 recordNo = 0;
	short id, ie;

	struct db_data_c {
		short byte_len;
		short color_no;
		short color_type;
	} holiday_c;

	union {
		void *recPtr;
		unsigned char *recChar;
	} db;

	if ( Md_version == 0 || Md_version > 3 ) return; //f[^̃o[W`FbN
	if ( Md_version < 3 ) {
		Md_InitRedDate();
	} else {
		CurrentCategory = 3;
		offset   = 0;
		recordNo = 0;
		if ( DmSeekRecordInCategory(Md_dbP, &recordNo, offset, dmSeekForward, CurrentCategory) == 0 ) {
			recHdl = DmQueryRecord (Md_dbP, recordNo);
			if ( recHdl != 0 ) {
				db.recPtr = MemHandleLock(recHdl);
				MemMove(&holiday_c.byte_len,  db.recPtr, 6);
				ie = 6;
				Md_max_color = holiday_c.color_no;
				if ( Md_max_color > Md_Max_Color_no ) Md_max_color = Md_Max_Color_no;//F𐧌
				for ( id=0; id<holiday_c.color_no; id++ ) {
					ie = ie + 2;
					if ( id < Md_max_color ) {
						MemMove(&Md_hol_color[id].hol_flag,  &db.recChar[ie], 22);  //2003/10/3
					}
					ie = ie + 22;  //2003/10/3
				}
//͂
//				if ( Md_max_color != holiday_c.color_no ) {
//					ie = ie + ( holiday_c.color_no - Md_max_color ) *  22;   //2003/11/20
//				}
//				for ( id=0; id<Md_max_color; id++ ) {
//					ix = db.recChar[ie];
//					if ( ix > Md_Max_ColorText_no ) {
//						iy = Md_Max_ColorText_no;
//					} else {
//						iy = ix;
//					}
//					MemMove(&Md_hol_color[id].text[0], &db.recChar[ie + 1], iy);
//					//ۂɂ́Aiy != ix ̂Ƃ'\0'ꏊ́A
//					//text[iy]text[iy-1]̂ǂ炩ŁA̔菈KvB
//					Md_hol_color[id].text[iy] = '\0';
//					ie = ie + ix + 1;
//				}
				MemHandleUnlock(recHdl);
			}
		} else {
			Md_InitRedDate();
		}
	}
	return;
}

//Փf[^t@CI[v
void Md_OpenRedDate(){
	UInt16 cardNo = 0;
	Err err = errNone;
	MemHandle recHdl;
	UInt16 recordNo = 0;
	void *recPtr;
	Int16 offset;
	UInt16 CurrentCategory;

//	Md_holidaym = 0;
	Md_dbP = DmOpenDatabaseByTypeCreator ( Md_DBType, Md_CreaID, dmModeReadOnly);
	if (Md_dbP==NULL) {
		return;
	}
	CurrentCategory = 1;
	offset = 0;
	recordNo = 0;
	DmSeekRecordInCategory(Md_dbP, &recordNo, offset, dmSeekForward, CurrentCategory);
	recHdl= DmQueryRecord (Md_dbP, recordNo);
	recPtr = MemHandleLock(recHdl);
	MemMove(&Md_version, recPtr, 2 );//f[^̃o[W荞
	MemHandleUnlock(recHdl);
	if ( Md_version == 0 || Md_version > 3 ) { //f[^̃o[W`FbN
		DmCloseDatabase (Md_dbP);
		return;
	}

	Md_GetColorDate();
}

//Փf[^荞
void Md_GetRedDate(short year, short month, unsigned long *holidayi){
//short year              ̔N
//short month @@@@@@ 
//unsigned long *holidayi@xf[^̃rbgp^[
	UInt16 cardNo = 0;
	Err err = errNone;
	MemHandle recHdl;
	UInt16 recordNo = 0;
	void *recPtr;
	struct db_data_d {
		short year;
		short month;
		unsigned long red[7];
	} holiday_d;
	Int16 offset;
	UInt16 CurrentCategory;

	MemSet(holidayi, Md_max_color*4, 0);
	if ( Md_version == 0 || Md_version > 3 ) return; //f[^̃o[W`FbN

	CurrentCategory = 4;
	offset = 0;
	recordNo = 0;
	for (;;) {//Pʂ̃f[^荞
		if ( DmSeekRecordInCategory(Md_dbP, &recordNo, offset, dmSeekForward, CurrentCategory) != 0 ) {
			return;
		}
		recHdl= DmQueryRecord (Md_dbP, recordNo);
		if ( recHdl == 0 ) break;
		recPtr = MemHandleLock(recHdl);
		MemMove(&holiday_d.year, recPtr, Md_max_color*4+4 );
		MemHandleUnlock(recHdl);
		if ( holiday_d.year == year && holiday_d.month == month ) {
			MemMove( &holidayi[0], holiday_d.red, Md_max_color*4 );
			break;
		}
		offset = 1;
	}
}

//Փf[^t@CN[Y
void Md_CloseRedDate(){
	if ( Md_version == 0 || Md_version > 3 ) return; //f[^̃o[W`FbN
	DmCloseDatabase (Md_dbP);
}

//mN̋L\
void Md_mono_disp(short x, short y, short no, short win_no) {
	short ib, xs, ys, xe, xd, yd;
	short xa, ya, xb, yb;
	if ( win_no == 1 ) {
		xa = -3; ya = -1; xb = 10; yb = 11;
	} else {
		xa = 0; ya = 0; xb = 11; yb = 9;
	}
	switch (no) {
	case 1:
	case 7:
		WinDrawLine (x+xa, y+ya, x+xb, y+ya);
		WinDrawLine (x+xa, y+ya, x+xa, y+yb);
		WinDrawLine (x+xa, y+yb, x+xb, y+yb);
		WinDrawLine (x+xb, y+ya, x+xb, y+yb);
		if ( no == 7 ) {
			WinDrawLine (x+xa,   y+yb,  x+xb,  y+ya);
			WinDrawLine (x+xa+1, y+yb,  x+xb,  y+ya+1);
		}
		break;
	case 2:
		WinDrawGrayLine (x+xa, y+ya, x+xb, y+ya);
		WinDrawGrayLine (x+xa, y+ya, x+xa, y+yb);
		WinDrawGrayLine (x+xa, y+yb, x+xb, y+yb);
		WinDrawGrayLine (x+xb, y+ya, x+xb, y+yb);
		break;
	case 3:
		xs = x + 9;
		ys = y + 4;
		xd = -1;
		yd = -1;
		break;
	case 4:
		xs = x + 9;
		ys = y + 4;
		xd = -1;
		yd = 1;
		break;
	case 5:
		xs = x - 2;
		ys = y + 4;
		xd = 1;
		yd = 1;
		break;
	case 6:
		xs = x - 2;
		ys = y + 4;
		xd = 1;
		yd = -1;
		break;
	}
	if (no >= 3 && no <= 6) {
		xe = xs;
		for ( ib=0; ib<5; ib++ ) {
			WinDrawLine (xs, ys, xe, ys);
			xs = xs + xd;
			ys = ys + yd;
		}
	}
}
